//
//  OSCPort.h
//dOSC
//  Created by dustin o'connor on 12/30/08.
//  Copyright 2008 nuMedia-sci.info. All rights reserved.
//	
//	Version 0.3:12/30/08 [iPhone-Controllerism support]


#import <Foundation/Foundation.h>
#import <dOSC/OSC-client.h>

@interface OSCPort : NSObject {
    int		_sock;
    char*	_types;
    OSCbuf* 	_oscBuffer;
}

#pragma mark _____ instance creation
// ipAddress is a character string representing a numeric address in the standard
// Internet . notation. *I don't do name lookup*
+ (id)oscPortToAddress:(const char*)ipAddress portNumber:(short)portNumber;

// socket needs to be a socket connected to the server
- (id)initWithSocket:(int)socket;

#pragma mark _____ actions
// If you use a single OSCPort in multiple threads, you need
// an NSLock/mutex around calls to these actions
- (BOOL)loadSynthDef:(char*)synthDefFilename;
- (BOOL)newSynthFromDef:(char*)synthDefName 
                synthID:(int)synthID 
            parentGroup:(int)parentGroup;
- (BOOL)freeSynth:(int)synthID;

- (BOOL)sendTo:(char*)address types:(char*)types, ...;

@end
